diff -ruN freeswan-1.9.orig/klips/net/ipsec/ipsec_rcv.c freeswan-1.9/klips/net/ipsec/ipsec_rcv.c
--- freeswan-1.9.orig/klips/net/ipsec/ipsec_rcv.c	Mon Feb 19 17:28:30 2001
+++ freeswan-1.9/klips/net/ipsec/ipsec_rcv.c	Wed May 16 10:57:20 2001
@@ -14,7 +14,7 @@
  * for more details.
  */
 
-char ipsec_rcv_c_version[] = "RCSID $Id: ipsec_rcv.c,v 1.75 2001/02/19 22:28:30 rgb Exp $";
+char ipsec_rcv_c_version[] = "RCSID $Id: ipsec_rcv.c,v 1.83 2001/05/04 16:45:47 rgb Exp $";
 
 #include <linux/config.h>
 #include <linux/version.h>
@@ -252,6 +252,14 @@
 		goto rcvleave;
 	}
 		
+#ifdef IPH_is_SKB_PULLED
+	/* In Linux 2.4.4, the IP header has been skb_pull()ed before the
+	   packet is passed to us. So we'll skb_push() to get back to it. */
+	if (skb->data == skb->h.raw) {
+		skb_push(skb, skb->h.raw - skb->nh.raw);
+	}
+#endif /* IPH_is_SKB_PULLED */
+	
 	ipp = (struct iphdr *)skb->data;
 	iphlen = ipp->ihl << 2;
 	/* dev->hard_header_len is unreliable and should not be used */
@@ -267,20 +275,26 @@
 		/* include any mac header while copying.. */
 		if(skb_headroom(skb) < hard_header_len) {
 			printk(KERN_WARNING "klips_error:ipsec_rcv: "
-			       "tried to skb_push hhlen=%d, %d available.  "
-			       "This should never happen, please report.\n",
-			       hard_header_len, skb_headroom(skb));
+			       "tried to skb_push hhlen=%d, %d available.  This should never happen, please report.\n",
+			       hard_header_len,
+			       skb_headroom(skb));
 			goto rcvleave;
 		}
 		skb_push(skb, hard_header_len);
-		if ((skb = skb_cow(skb, skb_headroom(skb))) == NULL) {
+		if
+#ifdef SKB_COW_NEW
+               (skb_cow(skb, skb_headroom(skb)) != 0)
+#else /* SKB_COW_NEW */
+               ((skb = skb_cow(skb, skb_headroom(skb))) == NULL)
+#endif /* SKB_COW_NEW */
+		{
 			goto rcvleave;
 		}
 		if(skb->len < hard_header_len) {
 			printk(KERN_WARNING "klips_error:ipsec_rcv: "
-			       "tried to skb_pull hhlen=%d, %d available.  "
-			       "This should never happen, please report.\n",
-			       hard_header_len, skb->len);
+			       "tried to skb_pull hhlen=%d, %d available.  This should never happen, please report.\n",
+			       hard_header_len,
+			       skb->len);
 			goto rcvleave;
 		}
 		skb_pull(skb, hard_header_len);
@@ -289,7 +303,8 @@
 #endif /* NET_21 */
 		
 	KLIPS_PRINT(debug_rcv, 
-		    "klips_debug:ipsec_rcv: <<< Info -- ");
+		    "klips_debug:ipsec_rcv: "
+		    "<<< Info -- ");
 	KLIPS_PRINTMORE(debug_rcv && skb->dev, "skb->dev=%s ",
 		    skb->dev->name ? skb->dev->name : "NULL");
 	KLIPS_PRINTMORE(debug_rcv && dev, "dev=%s ",
@@ -297,9 +312,8 @@
 	KLIPS_PRINTMORE(debug_rcv, "\n");
 
 	KLIPS_PRINT(debug_rcv && !(skb->dev && dev && (skb->dev == dev)),
-		    "klips_debug:ipsec_rcv: Informational -- "
-		    "**if this happens, find out why** "
-		    "skb->dev:%s is not equal to dev:%s\n",
+		    "klips_debug:ipsec_rcv: "
+		    "Informational -- **if this happens, find out why** skb->dev:%s is not equal to dev:%s\n",
 		    skb->dev ? (skb->dev->name ? skb->dev->name : "NULL") : "NULL",
 		    dev ? (dev->name ? dev->name : "NULL") : "NULL");
 
@@ -333,24 +347,25 @@
 				}
 				ipsecdev = skb->dev;
 				KLIPS_PRINT(debug_rcv,
-					    "klips_debug:ipsec_rcv: Info -- pkt "
-					    "already proc'ed a group of ipsec headers, "
-					    "processing next group of ipsec headers.\n");
+					    "klips_debug:ipsec_rcv: "
+					    "Info -- pkt already proc'ed a group of ipsec headers, processing next group of ipsec headers.\n");
 				break;
 			}
 			if((ipsecdev = ipsec_dev_get(name)) == NULL) {
 				KLIPS_PRINT(debug_rcv,
-					    "klips_error:ipsec_rcv: device %s does "
-					    "not exist\n", name);
+					    "klips_error:ipsec_rcv: "
+					    "device %s does not exist\n",
+					    name);
 			}
 			prv = ipsecdev ? (struct ipsecpriv *)(ipsecdev->priv) : NULL;
 			prvdev = prv ? (struct device *)(prv->dev) : NULL;
 			
 #if 0
 			KLIPS_PRINT(debug_rcv && prvdev, 
-				    "klips_debug:ipsec_rcv: physical device"
-				    " for device %s is %s\n",
-				    name, prvdev->name);
+				    "klips_debug:ipsec_rcv: "
+				    "physical device for device %s is %s\n",
+				    name,
+				    prvdev->name);
 #endif
 			if(prvdev && skb->dev &&
 			   !strcmp(prvdev->name, skb->dev->name)) {
@@ -368,20 +383,16 @@
 		}
 	} else {
 		KLIPS_PRINT(debug_rcv, 
-			    "klips_debug:ipsec_rcv: device supplied"
-			    " with skb is NULL\n");
+			    "klips_debug:ipsec_rcv: "
+			    "device supplied with skb is NULL\n");
 	}
 			
 	if(!stats) {
 		ipsecdev = NULL;
 	}
 	KLIPS_PRINT((debug_rcv && !stats),
-		    "klips_error:ipsec_rcv: packet received from physical "
-		    "I/F (%s) not connected to ipsec I/F.  Cannot record "
-		    "stats.\n"
-		    "klips_error          May not have SA for decoding.  "
-		    "Is IPSEC traffic expected on this I/F?  "
-		    "Check routing.\n",
+		    "klips_error:ipsec_rcv: "
+		    "packet received from physical I/F (%s) not connected to ipsec I/F.  Cannot record stats.  May not have SA for decoding.  Is IPSEC traffic expected on this I/F?  Check routing.\n",
 		    skb->dev ? (skb->dev->name ? skb->dev->name : "NULL") : "NULL");
 
 	KLIPS_IP_PRINT(debug_rcv, ipp);
@@ -415,9 +426,9 @@
 		/* XXX this will need to be 8 for IPv6 */
 		if ((proto == IPPROTO_ESP) && ((len - iphlen) % 4)) {
 			printk("klips_error:ipsec_rcv: "
-			       "got packet with content length = %d from %s "
-			       "-- should be on 4 octet boundary, packet dropped\n",
-			       len - iphlen, ipaddr_txt);
+			       "got packet with content length = %d from %s -- should be on 4 octet boundary, packet dropped\n",
+			       len - iphlen,
+			       ipaddr_txt);
 			if(stats) {
 				stats->rx_errors++;
 			}
@@ -467,11 +478,9 @@
 			next_header = ahp->ah_nh;
 			if (ahhlen != sizeof(struct ah)) {
 				KLIPS_PRINT(debug_rcv & DB_RX_INAU,
-					    "klips_debug:ipsec_rcv: bad "
-					    "authenticator length %d, expected "
-					    "%d from %s\n",
-					    ahhlen - ((caddr_t)(ahp->ah_data) -
-						      (caddr_t)ahp),
+					    "klips_debug:ipsec_rcv: "
+					    "bad authenticator length %d, expected %d from %s\n",
+					    ahhlen - ((caddr_t)(ahp->ah_data) - (caddr_t)ahp),
 					    AHHMAC_HASHLEN,
 					    ipaddr_txt);
 				if(stats) {
@@ -484,26 +493,34 @@
 #endif /* CONFIG_IPSEC_AH */
 		
 		/*
-		 * The spinlock is to prevent any other process from
-		 * accessing or deleting the structure while we are
-		 * using and updating it.
-		 */
-		spin_lock(&tdb_lock);
+		  The spinlock is to prevent any other process from
+		  accessing or deleting the TDB hash table or any of the
+		  TDBs while we are using and updating them.
+		  
+		  This is not optimal, but was relatively straightforward
+		  at the time.  A better way to do it has been planned for
+		  more than a year, to lock the hash table and put reference
+		  counts on each TDB instead.  This is not likely to happen
+		  in KLIPS1 unless a volunteer contributes it, but will be
+		  designed into KLIPS2.
+		*/
+		if(tdbprev == NULL) {
+			spin_lock(&tdb_lock);
+		}
 		
 #ifdef CONFIG_IPSEC_IPCOMP
 		if (proto == IPPROTO_COMP) {
 			unsigned int flags = 0;
 			if (tdbp == NULL) {
+				spin_unlock(&tdb_lock);
 				KLIPS_PRINT(debug_rcv,
 					    "klips_debug:ipsec_rcv: "
-					    "Incoming packet with outer IPCOMP "
-					    "header SA:%s: not yet supported "
-					    "by KLIPS, dropped\n", sa);
+					    "Incoming packet with outer IPCOMP header SA:%s: not yet supported by KLIPS, dropped\n",
+					    sa_len ? sa : " (error)");
 				if(stats) {
 					stats->rx_dropped++;
 				}
 
-				spin_unlock(&tdb_lock);
 				goto rcvleave;
 			}
 
@@ -516,27 +533,24 @@
 				   && ((ntohl(tdbp->tdb_said.spi) & 0x0000ffff)
 				       != ntohl(said.spi))))) {
 				char sa2[SATOA_BUF];
+				size_t sa_len2 = 0;
 
 				if(tdbp) {
-					sa_len = satoa(tdbp->tdb_said, 0, sa2, SATOA_BUF);
+					sa_len2 = satoa(tdbp->tdb_said, 0, sa2, SATOA_BUF);
 				}
 				KLIPS_PRINT(debug_rcv,
 					    "klips_debug:ipsec_rcv: "
-					    "Incoming packet with SA(IPCA):%s "
-					    "does not match policy SA(IPCA):%s "
-					    "cpi=%04x cpi->spi=%08x spi=%08x, spi->cpi=%04x for "
-					    "SA grouping, dropped.\n",
-					    sa,
-					    tdbp ? sa2 : "NULL",
+					    "Incoming packet with SA(IPCA):%s does not match policy SA(IPCA):%s cpi=%04x cpi->spi=%08x spi=%08x, spi->cpi=%04x for SA grouping, dropped.\n",
+					    sa_len ? sa : " (error)",
+					    tdbp ? (sa_len2 ? sa2 : " (error)") : "NULL",
 					    ntohs(compp->ipcomp_cpi),
 					    (__u32)ntohl(said.spi),
 					    tdbp ? (__u32)ntohl((tdbp->tdb_said.spi)) : 0,
 					    tdbp ? (__u16)(ntohl(tdbp->tdb_said.spi) & 0x0000ffff) : 0);
+				spin_unlock(&tdb_lock);
 				if(stats) {
 					stats->rx_dropped++;
 				}
-
-				spin_unlock(&tdb_lock);
 				goto rcvleave;
 			}
 
@@ -548,10 +562,10 @@
 
 			skb = skb_decompress(skb, tdbp, &flags);
 			if (!skb || flags) {
+				spin_unlock(&tdb_lock);
 				KLIPS_PRINT(debug_rcv,
 					    "klips_debug:ipsec_rcv: "
-					    "skb_decompress() returned "
-					    "error flags=%x, dropped.\n",
+					    "skb_decompress() returned error flags=%x, dropped.\n",
 					    flags);
 				if (stats) {
 				    if (flags)
@@ -559,8 +573,6 @@
 				    else
 					stats->rx_dropped++;
 				}
-
-				spin_unlock(&tdb_lock);
 				goto rcvleave;
 			}
 #ifdef NET_21
@@ -575,9 +587,8 @@
 
 			KLIPS_PRINT(debug_rcv,
 				    "klips_debug:ipsec_rcv: "
-				    "packet decompressed SA(IPCA):%s "
-				    "cpi->spi=%08x spi=%08x, spi->cpi=%04x, nh=%d.\n",
-				    sa,
+				    "packet decompressed SA(IPCA):%s cpi->spi=%08x spi=%08x, spi->cpi=%04x, nh=%d.\n",
+				    sa_len ? sa : " (error)",
 				    (__u32)ntohl(said.spi),
 				    tdbp ? (__u32)ntohl((tdbp->tdb_said.spi)) : 0,
 				    tdbp ? (__u16)(ntohl(tdbp->tdb_said.spi) & 0x0000ffff) : 0,
@@ -594,9 +605,9 @@
 		if (tdbp == NULL) {
 			spin_unlock(&tdb_lock);
 			KLIPS_PRINT(debug_rcv,
-				    "klips_debug:ipsec_rcv: no Tunnel Descriptor "
-				    "Block for SA:%s: incoming packet with no SA "
-				    "dropped\n", sa);
+				    "klips_debug:ipsec_rcv: "
+				    "no Tunnel Descriptor Block for SA:%s: incoming packet with no SA dropped\n",
+				    sa_len ? sa : " (error)");
 			if(stats) {
 				stats->rx_dropped++;
 			}
@@ -611,27 +622,27 @@
 				KLIPS_PRINT(debug_rcv,
 					    "klips_debug:ipsec_rcv: "
 					    "SA:%s, src=%s of pkt does not agree with expected SA source address policy.\n",
-					    sa, ipaddr_txt);
+					    sa_len ? sa : " (error)",
+					    ipaddr_txt);
 				if(stats) {
 					stats->rx_dropped++;
 				}
 				goto rcvleave;
 			}
-			{
-				ipaddr.s_addr = ipp->saddr;
-				addrtoa(ipaddr, 0, ipaddr_txt, sizeof(ipaddr_txt));
-				KLIPS_PRINT(debug_rcv,
-					    "klips_debug:ipsec_rcv: "
-					    "SA:%s, src=%s of pkt agrees with expected SA source address policy.\n",
-					    sa, ipaddr_txt);
-			}
+			ipaddr.s_addr = ipp->saddr;
+			addrtoa(ipaddr, 0, ipaddr_txt, sizeof(ipaddr_txt));
+			KLIPS_PRINT(debug_rcv,
+				    "klips_debug:ipsec_rcv: "
+				    "SA:%s, src=%s of pkt agrees with expected SA source address policy.\n",
+				    sa_len ? sa : " (error)",
+				    ipaddr_txt);
 			if(tdbnext) {
 				if(tdbnext != tdbp) {
 					spin_unlock(&tdb_lock);
 					KLIPS_PRINT(debug_rcv,
 						    "klips_debug:ipsec_rcv: "
 						    "unexpected SA:%s: does not agree with tdb->inext policy, dropped\n",
-						    sa);
+						    sa_len ? sa : " (error)");
 					if(stats) {
 						stats->rx_dropped++;
 					}
@@ -640,22 +651,21 @@
 				KLIPS_PRINT(debug_rcv,
 					    "klips_debug:ipsec_rcv: "
 					    "SA:%s grouping from previous SA is OK.\n",
-					    sa);
+					    sa_len ? sa : " (error)");
 			} else {
 				KLIPS_PRINT(debug_rcv,
 					    "klips_debug:ipsec_rcv: "
 					    "SA:%s First SA in group.\n",
-					    sa);
+					    sa_len ? sa : " (error)");
 			}
 			
-#if 1
 			if(tdbp->tdb_onext) {
 				if(tdbprev != tdbp->tdb_onext) {
 					spin_unlock(&tdb_lock);
 					KLIPS_PRINT(debug_rcv,
 						    "klips_debug:ipsec_rcv: "
 						    "unexpected SA:%s: does not agree with tdb->onext policy, dropped.\n",
-						    sa);
+						    sa_len ? sa : " (error)");
 					if(stats) {
 						stats->rx_dropped++;
 					}
@@ -664,15 +674,14 @@
 					KLIPS_PRINT(debug_rcv,
 						    "klips_debug:ipsec_rcv: "
 						    "SA:%s grouping to previous SA is OK.\n",
-						    sa);
+						    sa_len ? sa : " (error)");
 				}
 			} else {
 				KLIPS_PRINT(debug_rcv,
 					    "klips_debug:ipsec_rcv: "
 					    "SA:%s No previous backlink in group.\n",
-					    sa);
+					    sa_len ? sa : " (error)");
 			}
-#endif
 		}
 		
 		/* If it is in larval state, drop the packet, we cannot process yet. */
@@ -680,8 +689,7 @@
 			spin_unlock(&tdb_lock);
 			KLIPS_PRINT(debug_rcv,
 				    "klips_debug:ipsec_rcv: "
-				    "TDB in larval state, cannot be used yet, "
-				    "dropping packet.\n");
+				    "TDB in larval state, cannot be used yet, dropping packet.\n");
 			if(stats) {
 				stats->rx_dropped++;
 			}
@@ -692,8 +700,7 @@
 			spin_unlock(&tdb_lock);
 			KLIPS_PRINT(debug_rcv,
 				    "klips_debug:ipsec_rcv: "
-				    "TDB in dead state, cannot be used any more, "
-				    "dropping packet.\n");
+				    "TDB in dead state, cannot be used any more, dropping packet.\n");
 			if(stats) {
 				stats->rx_dropped++;
 			}
@@ -707,8 +714,8 @@
 			spin_unlock(&tdb_lock);
 			KLIPS_PRINT(debug_rcv,
 				    "klips_debug:ipsec_rcv: "
-				    "hard bytes lifetime of SA:%s has been reached, "
-				    "SA expired, incoming packet dropped.\n", sa);
+				    "hard bytes lifetime of SA:%s has been reached, SA expired, incoming packet dropped.\n",
+				    sa_len ? sa : " (error)");
 			if(stats) {
 				stats->rx_dropped++;
 			}
@@ -716,13 +723,14 @@
 		}
 		if(tdbp->tdb_lifetime_bytes_s &&
 		   (tdbp->tdb_lifetime_bytes_c > tdbp->tdb_lifetime_bytes_s)) {
+			if(tdbp->tdb_state != SADB_SASTATE_DYING) {
+				pfkey_expire(tdbp, 0);
+			}
 			tdbp->tdb_state = SADB_SASTATE_DYING;
 			KLIPS_PRINT(debug_rcv,
 				    "klips_debug:ipsec_rcv: "
-				    "soft bytes lifetime of SA:%s has been reached, "
-				    "SA expiring, soft expire message sent up, "
-				    "incoming packet still processed.\n", sa);
-			pfkey_expire(tdbp, 0);
+				    "soft bytes lifetime of SA:%s has been reached, SA expiring, soft expire message sent up, incoming packet still processed.\n",
+				    sa_len ? sa : " (error)");
 		}
 		
 		if(tdbp->tdb_lifetime_addtime_h &&
@@ -733,8 +741,8 @@
 			spin_unlock(&tdb_lock);
 			KLIPS_PRINT(debug_rcv,
 				    "klips_debug:ipsec_rcv: "
-				    "hard addtime lifetime of SA:%s has been reached, "
-				    "SA expired, incoming packet dropped.\n", sa);
+				    "hard addtime lifetime of SA:%s has been reached, SA expired, incoming packet dropped.\n",
+				    sa_len ? sa : " (error)");
 			if(stats) {
 				stats->rx_dropped++;
 			}
@@ -743,13 +751,14 @@
 		if(tdbp->tdb_lifetime_addtime_s &&
 		   ((jiffies / HZ) - tdbp->tdb_lifetime_addtime_c >
 		    tdbp->tdb_lifetime_addtime_s)) {
+			if(tdbp->tdb_state != SADB_SASTATE_DYING) {
+				pfkey_expire(tdbp, 0);
+			}
 			tdbp->tdb_state = SADB_SASTATE_DYING;
 			KLIPS_PRINT(debug_rcv,
 				    "klips_debug:ipsec_rcv: "
-				    "soft addtime lifetime of SA:%s has been reached, "
-				    "SA expiring, soft expire message sent up, "
-				    "incoming packet still processed.\n", sa);
-			pfkey_expire(tdbp, 0);
+				    "soft addtime lifetime of SA:%s has been reached, SA expiring, soft expire message sent up, incoming packet still processed.\n",
+				    sa_len ? sa : " (error)");
 		}
 		
 		if(tdbp->tdb_lifetime_usetime_c) {
@@ -761,8 +770,8 @@
 				spin_unlock(&tdb_lock);
 				KLIPS_PRINT(debug_rcv,
 					    "klips_debug:ipsec_rcv: "
-					    "hard usetime lifetime of SA:%s has been reached, "
-					    "SA expired, incoming packet dropped.\n", sa);
+					    "hard usetime lifetime of SA:%s has been reached, SA expired, incoming packet dropped.\n",
+					    sa_len ? sa : " (error)");
 				if(stats) {
 					stats->rx_dropped++;
 				}
@@ -771,13 +780,14 @@
 			if(tdbp->tdb_lifetime_usetime_s &&
 			   ((jiffies / HZ) - tdbp->tdb_lifetime_usetime_c >
 			    tdbp->tdb_lifetime_usetime_s)) {
+				if(tdbp->tdb_state != SADB_SASTATE_DYING) {
+					pfkey_expire(tdbp, 0);
+				}
 				tdbp->tdb_state = SADB_SASTATE_DYING;
 				KLIPS_PRINT(debug_rcv,
 					    "klips_debug:ipsec_rcv: "
-					    "soft usetime lifetime of SA:%s has been reached, "
-					    "SA expiring, soft expire message sent up, "
-					    "incoming packet still processed.\n", sa);
-				pfkey_expire(tdbp, 0);
+					    "soft usetime lifetime of SA:%s has been reached, SA expiring, soft expire message sent up, incoming packet still processed.\n",
+					    sa_len ? sa : " (error)");
 			}
 		}
 		
@@ -788,8 +798,8 @@
 			spin_unlock(&tdb_lock);
 			KLIPS_PRINT(debug_rcv,
 				    "klips_debug:ipsec_rcv: "
-				    "hard packets lifetime of SA:%s has been reached, "
-				    "SA expired, incoming packet dropped.\n", sa);
+				    "hard packets lifetime of SA:%s has been reached, SA expired, incoming packet dropped.\n",
+				    sa_len ? sa : " (error)");
 			if(stats) {
 				stats->rx_dropped++;
 			}
@@ -797,13 +807,14 @@
 		}
 		if(tdbp->tdb_lifetime_packets_s &&
 		   (tdbp->tdb_lifetime_packets_c > tdbp->tdb_lifetime_packets_s)) {
+			if(tdbp->tdb_state != SADB_SASTATE_DYING) {
+				pfkey_expire(tdbp, 0);
+			}
 			tdbp->tdb_state = SADB_SASTATE_DYING;
 			KLIPS_PRINT(debug_rcv,
 				    "klips_debug:ipsec_rcv: "
-				    "soft packets lifetime of SA:%s has been reached, "
-				    "SA expiring, soft expire message sent up, "
-				    "incoming packet still processed.\n", sa);
-			pfkey_expire(tdbp, 0);
+				    "soft packets lifetime of SA:%s has been reached, SA expiring, soft expire message sent up, incoming packet still processed.\n",
+				    sa_len ? sa : " (error)");
 		}
 		
 		/* authenticate, if required */
@@ -823,24 +834,26 @@
 			authlen = 0;
 			break;
 		default:
+			tdbp->tdb_alg_errs += 1;
+			spin_unlock(&tdb_lock);
 			if(stats) {
 				stats->rx_errors++;
 			}
-			tdbp->tdb_alg_errs += 1;
-			spin_unlock(&tdb_lock);
 			goto rcvleave;
 		}
 		ilen = len - iphlen - authlen;
 		
 #ifdef CONFIG_IPSEC_ESP
 		KLIPS_PRINT(proto == IPPROTO_ESP && debug_rcv, 
-			    "klips_debug:ipsec_rcv: packet from %s received with"
-			    " seq=%d (iv)=0x%08x%08x iplen=%d esplen=%d sa=%s\n",
+			    "klips_debug:ipsec_rcv: "
+			    "packet from %s received with seq=%d (iv)=0x%08x%08x iplen=%d esplen=%d sa=%s\n",
 			    ipaddr_txt,
 			    (__u32)ntohl(espp->esp_rpl),
 			    (__u32)ntohl(*((__u32 *)(espp->esp_iv)    )),
 			    (__u32)ntohl(*((__u32 *)(espp->esp_iv) + 1)),
-			    len, ilen, sa);
+			    len,
+			    ilen,
+			    sa_len ? sa : " (error)");
 #endif /* !CONFIG_IPSEC_ESP */
 		
 		switch(proto) {
@@ -863,7 +876,7 @@
 			deltdbchain(tdbp);
 			spin_unlock(&tdb_lock);
 			KLIPS_PRINT(debug_rcv,
-				    "klips_debug:ipsec_tunnel_start_xmit: "
+				    "klips_debug:ipsec_rcv: "
 				    "replay window counter rolled, expiring SA.\n");
 			if(stats) {
 				stats->rx_dropped++;
@@ -872,15 +885,15 @@
 		}
 
 		if (!ipsec_checkreplaywindow(tdbp, replay)) {
+			tdbp->tdb_replaywin_errs += 1;
+			spin_unlock(&tdb_lock);
 			KLIPS_PRINT(debug_rcv & DB_RX_REPLAY,
-				    "klips_debug:ipsec_rcv: duplicate frame from %s,"
-				    " packet dropped\n",
+				    "klips_debug:ipsec_rcv: "
+				    "duplicate frame from %s, packet dropped\n",
 				    ipaddr_txt);
 			if(stats) {
 				stats->rx_dropped++;
 			}
-			tdbp->tdb_replaywin_errs += 1;
-			spin_unlock(&tdb_lock);
 			goto rcvleave;
 		}
 		
@@ -889,8 +902,10 @@
 		 */
 		
 		KLIPS_PRINT(debug_rcv,
-			    "klips_debug:ipsec_rcv: encalg = %d, authalg = %d.\n",
-			    tdbp->tdb_encalg, tdbp->tdb_authalg);
+			    "klips_debug:ipsec_rcv: "
+			    "encalg = %d, authalg = %d.\n",
+			    tdbp->tdb_encalg,
+			    tdbp->tdb_authalg);
 		
 		if(tdbp->tdb_authalg) {
 			switch(tdbp->tdb_authalg) {
@@ -959,19 +974,21 @@
 			}
 		
 			if(!authenticator) {
+				tdbp->tdb_auth_errs += 1;
+				spin_unlock(&tdb_lock);
 				if(stats) {
 					stats->rx_dropped++;
 				}
-				tdbp->tdb_auth_errs += 1;
-				spin_unlock(&tdb_lock);
 				goto rcvleave;
 			}
 
 			if (memcmp(hash, authenticator, authlen)) {
+				tdbp->tdb_auth_errs += 1;
+				spin_unlock(&tdb_lock);
 				KLIPS_PRINT(debug_rcv & DB_RX_INAU,
-					    "klips_debug:ipsec_rcv: auth failed on incoming "
-					    "packet from %s: hash=%08x%08x%08x "
-					    "auth=%08x%08x%08x, dropped\n", ipaddr_txt,
+					    "klips_debug:ipsec_rcv: "
+					    "auth failed on incoming packet from %s: hash=%08x%08x%08x auth=%08x%08x%08x, dropped\n",
+					    ipaddr_txt,
 					    *(__u32*)&hash[0],
 					    *(__u32*)&hash[4],
 					    *(__u32*)&hash[8],
@@ -981,12 +998,11 @@
 				if(stats) {
 					stats->rx_dropped++;
 				}
-				tdbp->tdb_auth_errs += 1;
-				spin_unlock(&tdb_lock);
 				goto rcvleave;
 			} else {
 				KLIPS_PRINT(debug_rcv,
-					    "klips_debug:ipsec_rcv: authentication successful.\n");
+					    "klips_debug:ipsec_rcv: "
+					    "authentication successful.\n");
 			}
 			
 			memset((caddr_t)&tctx, 0, sizeof(tctx));
@@ -994,15 +1010,15 @@
 		}
 
 		if (!ipsec_updatereplaywindow(tdbp, replay)) {
+			tdbp->tdb_replaywin_errs += 1;
+			spin_unlock(&tdb_lock);
 			KLIPS_PRINT(debug_rcv & DB_RX_REPLAY,
-				    "klips_debug:ipsec_rcv: duplicate frame from %s,"
-				    " packet dropped\n",
+				    "klips_debug:ipsec_rcv: "
+				    "duplicate frame from %s, packet dropped\n",
 				    ipaddr_txt);
 			if(stats) {
 				stats->rx_dropped++;
 			}
-			tdbp->tdb_replaywin_errs += 1;
-			spin_unlock(&tdb_lock);
 			goto rcvleave;
 		}
 		
@@ -1019,11 +1035,11 @@
 				esphlen = offsetof(struct esp, esp_iv);
 				break;
 			default:
+				tdbp->tdb_alg_errs += 1;
+				spin_unlock(&tdb_lock);
 				if(stats) {
 					stats->rx_errors++;
 				}
-				tdbp->tdb_alg_errs += 1;
-				spin_unlock(&tdb_lock);
 				goto rcvleave;
 			}
 			idat += esphlen;
@@ -1032,15 +1048,15 @@
 			switch(tdbp->tdb_encalg) {
 			case ESP_3DES:
 				if ((ilen) % 8) {
+					tdbp->tdb_encsize_errs += 1;
+					spin_unlock(&tdb_lock);
 					printk("klips_error:ipsec_rcv: "
-					       "got packet with esplen = %d from %s "
-					       "-- should be on 8 octet boundary, packet dropped\n",
-					       ilen, ipaddr_txt);
+					       "got packet with esplen = %d from %s -- should be on 8 octet boundary, packet dropped\n",
+					       ilen,
+					       ipaddr_txt);
 					if(stats) {
 						stats->rx_errors++;
 					}
-					tdbp->tdb_encsize_errs += 1;
-					spin_unlock(&tdb_lock);
 					goto rcvleave;
 				}
 				des_ede3_cbc_encrypt(idat, idat, ilen,
@@ -1123,23 +1139,25 @@
 				(void *)(skb->data), iphlen);
 			if(skb->len < esphlen) {
 				spin_unlock(&tdb_lock);
-				printk(KERN_WARNING "klips_error:ipsec_rcv: "
-				       "tried to skb_pull esphlen=%d, %d available.  "
-				       "This should never happen, please report.\n",
+				printk(KERN_WARNING
+				       "klips_error:ipsec_rcv: "
+				       "tried to skb_pull esphlen=%d, %d available.  This should never happen, please report.\n",
 				       esphlen, (int)(skb->len));
 				goto rcvleave;
 			}
 			skb_pull(skb, esphlen);
 
 			KLIPS_PRINT(debug_rcv & DB_RX_PKTRX,
-				    "klips_debug:ipsec_rcv: trimming to %d.\n",
+				    "klips_debug:ipsec_rcv: "
+				    "trimming to %d.\n",
 				    len - esphlen - pad);
 			if(pad + esphlen <= len) {
 			        skb_trim(skb, len - esphlen - pad);
 			} else {
 				spin_unlock(&tdb_lock);
 			        KLIPS_PRINT(debug_rcv & DB_RX_PKTRX,
-				            "klips_debug:ipsec_rcv: bogus packet, size is zero or negative, dropping.\n");
+				            "klips_debug:ipsec_rcv: "
+					    "bogus packet, size is zero or negative, dropping.\n");
 				goto rcvleave;
 			}
 		break;
@@ -1151,10 +1169,11 @@
 				(void *)(skb->data), iphlen);
 			if(skb->len < ahhlen) {
 				spin_unlock(&tdb_lock);
-				printk(KERN_WARNING "klips_error:ipsec_rcv: "
-				       "tried to skb_pull ahhlen=%d, %d available.  "
-				       "This should never happen, please report.\n",
-				       ahhlen, (int)(skb->len));
+				printk(KERN_WARNING
+				       "klips_error:ipsec_rcv: "
+				       "tried to skb_pull ahhlen=%d, %d available.  This should never happen, please report.\n",
+				       ahhlen,
+				       (int)(skb->len));
 				goto rcvleave;
 			}
 			skb_pull(skb, ahhlen);
@@ -1187,8 +1206,10 @@
 		ipp->check = ip_fast_csum((unsigned char *)dat, iphlen >> 2);
 		
 		KLIPS_PRINT(debug_rcv & DB_RX_PKTRX,
-			    "klips_debug:ipsec_rcv: after <%s%s%s>, SA:%s:\n",
-					    TDB_XFORM_NAME(tdbp), sa);
+			    "klips_debug:ipsec_rcv: "
+			    "after <%s%s%s>, SA:%s:\n",
+			    TDB_XFORM_NAME(tdbp),
+			    sa_len ? sa : " (error)");
 		KLIPS_IP_PRINT(debug_rcv & DB_RX_PKTRX, ipp);
 		
 		skb->protocol = htons(ETH_P_IP);
@@ -1203,7 +1224,7 @@
 					KLIPS_PRINT(debug_rcv,
 						    "klips_debug:ipsec_rcv: "
 						    "SA:%s, backpolicy does not agree with fwdpolicy.\n",
-						    sa);
+						    sa_len ? sa : " (error)");
 					if(stats) {
 						stats->rx_dropped++;
 					}
@@ -1212,7 +1233,7 @@
 				KLIPS_PRINT(debug_rcv,
 					    "klips_debug:ipsec_rcv: "
 					    "SA:%s, backpolicy agrees with fwdpolicy.\n",
-					    sa);
+					    sa_len ? sa : " (error)");
 				if(!(   (ipp->protocol == IPPROTO_AH  )
 					|| (ipp->protocol == IPPROTO_ESP )
 					|| (ipp->protocol == IPPROTO_IPIP)
@@ -1224,7 +1245,7 @@
 					KLIPS_PRINT(debug_rcv,
 						    "klips_debug:ipsec_rcv: "
 						    "packet with incomplete policy dropped, last successful SA:%s.\n",
-						    sa);
+						    sa_len ? sa : " (error)");
 					if(stats) {
 						stats->rx_dropped++;
 					}
@@ -1233,12 +1254,12 @@
 				KLIPS_PRINT(debug_rcv,
 					    "klips_debug:ipsec_rcv: "
 					    "SA:%s, Another IPSEC header to process.\n",
-					    sa);
+					    sa_len ? sa : " (error)");
 			} else {
 				KLIPS_PRINT(debug_rcv,
 					    "klips_debug:ipsec_rcv: "
 					    "No tdb_inext from this SA:%s.\n",
-					    sa);
+					    sa_len ? sa : " (error)");
 			}
 		}
 
@@ -1288,7 +1309,7 @@
 			KLIPS_PRINT(debug_rcv,
 				    "klips_debug:ipsec_rcv: "
 				    "SA:%s, Hey!  How did this get through?  Dropped.\n",
-				    sa);
+				    sa_len ? sa : " (error)");
 			if(stats) {
 				stats->rx_dropped++;
 			}
@@ -1296,12 +1317,14 @@
 		}
 		if(sysctl_ipsec_inbound_policy_check && (tdbnext = tdbp->tdb_inext)) {
 			char sa2[SATOA_BUF];
-			sa_len = satoa(tdbnext->tdb_said, 0, sa2, SATOA_BUF);
+			size_t sa_len2;
+			sa_len2 = satoa(tdbnext->tdb_said, 0, sa2, SATOA_BUF);
 			spin_unlock(&tdb_lock);
 			KLIPS_PRINT(debug_rcv,
 				    "klips_debug:ipsec_rcv: "
 				    "unexpected SA:%s after IPIP SA:%s\n",
-				    sa2, sa);
+				    sa_len2 ? sa2 : " (error)",
+				    sa_len ? sa : " (error)");
 			if(stats) {
 				stats->rx_dropped++;
 			}
@@ -1355,15 +1378,15 @@
 		 * accessing or deleting the tdb while we are using and
 		 * updating it.
 		 */
-		/* spin_lock(&tdb_lock); */
+		spin_lock(&tdb_lock);
 
 		policy_tdb = gettdb(&policy_said);
 		if (policy_tdb == NULL) {
-			/* spin_unlock(&tdb_lock); */
+			spin_unlock(&tdb_lock);
 			KLIPS_PRINT(debug_rcv,
 				    "klips_debug:ipsec_rcv: "
-				    "no Tunnel Descriptor Block for SA%s: "
-				    "incoming packet with no policy SA, dropped.\n", sa);
+				    "no Tunnel Descriptor Block for SA%s: incoming packet with no policy SA, dropped.\n",
+				    sa_len ? sa : " (error)");
 			goto rcvleave;
 		}
 		
@@ -1371,7 +1394,8 @@
 
 		KLIPS_PRINT(debug_rcv,
 			    "klips_debug:ipsec_rcv: "
-			    "found policy Tunnel Descriptor Block -- SA:%s\n", sa);
+			    "found policy Tunnel Descriptor Block -- SA:%s\n",
+			    sa_len ? sa : " (error)");
 		while(1) {
 			if(policy_tdb->tdb_inext) {
 				policy_tdb = policy_tdb->tdb_inext;
@@ -1380,11 +1404,11 @@
 			}
 		}
 		if(policy_tdb != tdbp) {
-			/* spin_unlock(&tdb_lock); */
+			spin_unlock(&tdb_lock);
 			KLIPS_PRINT(debug_rcv,
 				    "klips_debug:ipsec_rcv: "
-				    " Tunnel Descriptor Block for SA%s: "
-				    "incoming packet with different policy SA, dropped.\n", sa);
+				    "Tunnel Descriptor Block for SA%s: incoming packet with different policy SA, dropped.\n",
+				    sa_len ? sa : " (error)");
 			goto rcvleave;
 		}
 
@@ -1408,12 +1432,12 @@
 		}
 		
 		if(skb->len < iphlen) {
+			spin_unlock(&tdb_lock);
 			printk(KERN_WARNING "klips_debug:ipsec_rcv: "
-			       "tried to skb_pull iphlen=%d, %d available.  "
-			       "This should never happen, please report.\n",
-			       iphlen, (int)(skb->len));
+			       "tried to skb_pull iphlen=%d, %d available.  This should never happen, please report.\n",
+			       iphlen,
+			       (int)(skb->len));
 
-			spin_unlock(&tdb_lock);
 			goto rcvleave;
 		}
 		skb_pull(skb, iphlen);
@@ -1432,7 +1456,8 @@
 		skb->protocol = htons(ETH_P_IP);
 		skb->ip_summed = 0;
 		KLIPS_PRINT(debug_rcv & DB_RX_PKTRX,
-			    "klips_debug:ipsec_rcv: IPIP tunnel stripped.\n");
+			    "klips_debug:ipsec_rcv: "
+			    "IPIP tunnel stripped.\n");
 		KLIPS_IP_PRINT(debug_rcv & DB_RX_PKTRX, ipp);
 	}
 
@@ -1469,7 +1494,10 @@
 			}
 			goto rcvleave;
 		}
-		/* XXX need a tdb for updating ratio counters XXX */
+		/*
+		  XXX need a TDB for updating ratio counters but it is not
+		  following policy anyways so it is not a priority
+		*/
 		skb = skb_decompress(skb, NULL, &flags);
 		if (!skb || flags) {
 			KLIPS_PRINT(debug_rcv & DB_RX_PKTRX,
@@ -1481,11 +1509,6 @@
 			}
 			goto rcvleave;
 		}
-#ifdef NET_21
-		ipp = skb->nh.iph;
-#else /* NET_21 */
-		ipp = skb->ip_hdr;
-#endif /* NET_21 */
 	}
 #endif /* CONFIG_IPSEC_IPCOMP */
 
@@ -1497,7 +1520,8 @@
 #endif /* CONFIG_NETFILTER_DEBUG */
 #endif /* SKB_RESET_NFCT */
 	KLIPS_PRINT(debug_rcv & DB_RX_PKTRX,
-		    "klips_debug:ipsec_rcv: netif_rx() called.\n");
+		    "klips_debug:ipsec_rcv: "
+		    "netif_rx() called.\n");
 	netif_rx(skb);
 
 	MOD_DEC_USE_COUNT;
@@ -1558,6 +1582,36 @@
 
 /*
  * $Log: ipsec_rcv.c,v $
+ * Revision 1.83  2001/05/04 16:45:47  rgb
+ * Remove unneeded code.  ipp is not used after this point.
+ *
+ * Revision 1.82  2001/05/04 16:36:00  rgb
+ * Fix skb_cow() call for 2.4.4. (SS)
+ *
+ * Revision 1.81  2001/05/02 14:46:53  rgb
+ * Fix typo for compiler directive to pull IPH back.
+ *
+ * Revision 1.80  2001/04/30 19:46:34  rgb
+ * Update for 2.4.4.  We now receive the skb with skb->data pointing to
+ * h.raw.
+ *
+ * Revision 1.79  2001/04/23 15:01:15  rgb
+ * Added spin_lock() check to prevent double-locking for multiple
+ * transforms and hence kernel lock-ups with SMP kernels.
+ * Minor spin_unlock() adjustments to unlock before non-dependant prints
+ * and IPSEC device stats updates.
+ *
+ * Revision 1.78  2001/04/21 23:04:24  rgb
+ * Check if soft expire has already been sent before sending another to
+ * prevent ACQUIRE flooding.
+ *
+ * Revision 1.77  2001/03/16 07:35:20  rgb
+ * Ditch extra #if 1 around now permanent policy checking code.
+ *
+ * Revision 1.76  2001/02/27 22:24:54  rgb
+ * Re-formatting debug output (line-splitting, joining, 1arg/line).
+ * Check for satoa() return codes.
+ *
  * Revision 1.75  2001/02/19 22:28:30  rgb
  * Minor change to virtual device discovery code to assert which I/F has
  * been found.
